# Backing up currently running nginx sites.
mkdir -p "${SITES_BACKUP:?}"
cp -f "${APP_DIR:?}/nginx/sites-enabled/"* "${SITES_BACKUP}"

# Removing all data from previous installation.
rm -rf "${APP_DIR:?}/"*

# Copying application to deploy location
rsync -av --exclude=".git" . "${APP_DIR}"
cd "${APP_DIR}" || exit 1

# Copying ssl certificates and backup data in nginx directory.
mkdir -p "${APP_DIR:?}/nginx/ssl"
cp "${SSL_DIR:?}/"* "${APP_DIR:?}/nginx/ssl/"
cp "${SITES_BACKUP:?}/"* "${APP_DIR:?}/nginx/sites-enabled/"

# Running nginx systemd service. Described in ./systemd/nginx_proxy.service
sudo cp -f "${APP_DIR:?}/systemd/"* /lib/systemd/system/
sudo systemctl daemon-reload
sudo systemctl restart nginx_proxy.service
